File attachment in EJ2 JavaScript Rich text editor control

20 Jul 20238 minutes to read

The Rich Text Editor allows you to attach a file based on the file upload. You can attach your files using the file upload or drag-and-drop from your local path. When the file upload gets success, the attachment link inserts into the content.

In the below sample, configure the saveUrl and path properties to achieve file attachments.

    1. saveUrl: Provides service URL to save the files.
    2. path: Specifies the location to store the image.

The following sample illustrates how to attach a file in the Rich Text Editor.

import { RichTextEditor, Toolbar, Link, Image, Count, HtmlEditor, QuickToolbar, NodeSelection } from '@syncfusion/ej2-richtexteditor';
RichTextEditor.Inject(Toolbar, Link, Image, Count, HtmlEditor, QuickToolbar, NodeSelection);
import { Uploader } from '@syncfusion/ej2-inputs';

let selection: NodeSelection = new NodeSelection();
let range: Range;
let saveSelection: NodeSelection;
let defaultRTE: RichTextEditor = new RichTextEditor({
  insertImageSettings: {
   saveUrl: "[SERVICE_HOSTED_PATH]/api/uploadbox/Save",
    path: "../Files/"
  }
});
defaultRTE.appendTo("#defaultRTE");
let uploadObj: Uploader = new Uploader({
  asyncSettings: {
    saveUrl: "[SERVICE_HOSTED_PATH]/api/uploadbox/Save",
  },
  dropArea: defaultRTE.inputElement,
  success: onUploadSuccess
});
uploadObj.appendTo("#fileupload");
function onUploadSuccess(args: any): void {
  (defaultRTE.contentModule.getEditPanel() as HTMLElement).focus();
  range = selection.getRange(document);
  saveSelection = selection.save(range, document);
  let fileUrl: any =
      document.URL + defaultRTE.insertImageSettings.path + args.file.name;
  if (defaultRTE.formatter.getUndoRedoStack().length === 0) {
      defaultRTE.formatter.saveData();
  }
  saveSelection.restore();
  defaultRTE.executeCommand('createLink', { url: fileUrl, text: fileUrl, selection: saveSelection });
  defaultRTE.formatter.saveData();
  defaultRTE.formatter.enableUndo(defaultRTE);
  this.clearAll();
}

To configure server-side handler, refer the below code.

int x = 0;
string file;
 [AcceptVerbs("Post")]
        public void Save()
        {
            try
            {
                var httpPostedFile = System.Web.HttpContext.Current.Request.Files["UploadFiles"];
                file = httpPostedFile.FileName;
                if (httpPostedFile != null)
                {
                    Console.WriteLine(System.Web.HttpContext.Current.Server.MapPath("~/Files"));
                    var fileSave = System.Web.HttpContext.Current.Server.MapPath("~/Files");
                    if (!Directory.Exists(fileSave))
                    {
                        Directory.CreateDirectory(fileSave);
                    }
                    var fileName = Path.GetFileName(httpPostedFile.FileName);
                    var fileSavePath = Path.Combine(fileSave, fileName);
                    while (System.IO.File.Exists(fileSavePath))
                    {
                        file = "rte" + x + "-" + fileName;
                        fileSavePath = Path.Combine(fileSave, file);
                        x++;
                    }
                    if (!System.IO.File.Exists(fileSavePath))
                    {
                        httpPostedFile.SaveAs(fileSavePath);
                        HttpResponse Response = System.Web.HttpContext.Current.Response;
                        Response.Clear();
                        Response.Headers.Add("name", file);
                        Response.ContentType = "application/json; charset=utf-8";
                        Response.StatusDescription = "File uploaded succesfully";
                        Response.Headers.Add("url", fileSavePath);
                        Response.End();
                    }
                }
            }
            catch (Exception e)
            {
                HttpResponse Response = System.Web.HttpContext.Current.Response;
                Response.Clear();
                Response.ContentType = "application/json; charset=utf-8";
                Response.StatusCode = 204;
                Response.Status = "204 No Content";
                Response.StatusDescription = e.Message;
                Response.End();
            }
        }

File attachment in Angular Rich text editor component

4 Apr 202310 minutes to read

The Rich Text Editor allows you to attach a file based on the file upload. You can attach your files using the file upload or drag-and-drop from your local path. When the file upload gets success, the attachment link inserts into the content.

In the below sample, configure the saveUrl and path properties to achieve file attachments.

    1. saveUrl: Provides service URL to save the files.
    2. path: Specifies the location to store the image.

The following sample illustrates how to attach a file in the RichTextEditor.

<ejs-richtexteditor id='defaultRTE' #sample [insertImageSettings]='insertImageSettings'>
    <ng-template #valueTemplate>
        <p>The Rich Text Editor triggers events based on its actions. </p>
        <p> The events can be used as an extension point to perform custom operations.</p>
        <ul>
            <li>created - Triggers when the component is rendered.</li>
            <li>change - Triggers only when Rich Text Editor is blurred and changes are done to the content.</li>
            <li>focus - Triggers when Rich Text Editor is focused in.</li>
            <li>blur - Triggers when Rich Text Editor is focused out.</li>
            <li>actionBegin - Triggers before command execution using toolbar items or executeCommand method.</li>
            <li>actionComplete - Triggers after command execution using toolbar items or executeCommand method.</li>
            <li>destroyed – Triggers when the component is destroyed.</li>
        </ul>
    </ng-template>
</ejs-richtexteditor>

<ejs-uploader #defaultupload id='defaultfileupload' [asyncSettings]='path' [dropArea]='dropElement' (success)='onImageUploadSuccess($event)'></ejs-uploader>
import { Component, ViewChild } from '@angular/core';
import { ToolbarService, LinkService, ImageService, HtmlEditorService, RichTextEditorComponent , NodeSelection } from '@syncfusion/ej2-angular-richtexteditor';
@Component({
    selector: 'app-root',
    templateUrl: 'app.compoenent.html',
    providers: [ToolbarService, LinkService, ImageService, HtmlEditorService , NodeSelection ]
})
export class AppComponent  {
@ViewChild('sample') public rteObj: RichTextEditorComponent;
@ViewChild('defaultupload')  public uploadObj: uploaderComponent;

public insertImageSettings: object = {
    saveUrl: "[SERVICE_HOSTED_PATH]/api/uploadbox/Save",
    path: "../Files/"
};

    public path: Object = {
        saveUrl: '[SERVICE_HOSTED_PATH]/api/uploadbox/Save',
    };
     public dropElement ='#defaultRTE'
  public selection: NodeSelection = new NodeSelection();
    public range: Range;
    public saveSelection: NodeSelection;
  public onImageUploadSuccess = (args: any) => {  
      this.rteObj.contentModule.getEditPanel().focus();
        this.range = this.selection.getRange(document);
        this.saveSelection = this.selection.save(this.range, document);
        var fileUrl = document.URL + this.rteObj.insertImageSettings.path + args.file.name;
        if (rteObj.formatter.getUndoRedoStack().length === 0) {
            rteObj.formatter.saveData();
        }
        saveSelection.restore();
        rteObj.executeCommand('createLink', { url: fileUrl, text: fileUrl, selection: saveSelection });
        rteObj.formatter.saveData();
        rteObj.formatter.enableUndo(rteObj);
        this.uploadObj.clearAll();
}
}

To config server-side handler, refer the below code.

int x = 0;
string file;
 [AcceptVerbs("Post")]
        public void Save()
        {
            try
            {
                var httpPostedFile = System.Web.HttpContext.Current.Request.Files["UploadFiles"];
                file = httpPostedFile.FileName;
                if (httpPostedFile != null)
                {
                    Console.WriteLine(System.Web.HttpContext.Current.Server.MapPath("~/Files"));
                    var fileSave = System.Web.HttpContext.Current.Server.MapPath("~/Files");
                    if (!Directory.Exists(fileSave))
                    {
                        Directory.CreateDirectory(fileSave);
                    }
                    var fileName = Path.GetFileName(httpPostedFile.FileName);
                    var fileSavePath = Path.Combine(fileSave, fileName);
                    while (System.IO.File.Exists(fileSavePath))
                    {
                        file = "rte" + x + "-" + fileName;
                        fileSavePath = Path.Combine(fileSave, file);
                        x++;
                    }
                    if (!System.IO.File.Exists(fileSavePath))
                    {
                        httpPostedFile.SaveAs(fileSavePath);
                        HttpResponse Response = System.Web.HttpContext.Current.Response;
                        Response.Clear();
                        Response.Headers.Add("name", file);
                        Response.ContentType = "application/json; charset=utf-8";
                        Response.StatusDescription = "File uploaded succesfully";
                        Response.Headers.Add("url", fileSavePath);
                        Response.End();
                    }
                }
            }
            catch (Exception e)
            {
                HttpResponse Response = System.Web.HttpContext.Current.Response;
                Response.Clear();
                Response.ContentType = "application/json; charset=utf-8";
                Response.StatusCode = 204;
                Response.Status = "204 No Content";
                Response.StatusDescription = e.Message;
                Response.End();
            }
        }

File attachment in Vue Rich text editor component

16 Mar 20239 minutes to read

The Rich Text Editor allows you to attach a file based on the file upload. You can attach your files using the file upload or drag-and-drop from your local path. When the file upload gets success, the attachment link inserts into the content.

In the below sample, configure the saveUrl and path properties to achieve file attachments.

    1. saveUrl: Provides service URL to save the files.
    2. path: Specifies the location to store the image.

The following sample illustrates how to attach a file in the Rich Text Editor.

<template>
<div>
<div class="control-section">
    <div class="sample-container">
        <div class="default-section">
        <ejs-richtexteditor ref="rteObj" :insertImageSettings="insertImageSettings">
       <p>The Rich Text Editor component is WYSIWYG ("what you see is what you get") editor that provides the best user experience to create and update the content. Users can format their content using standard toolbar commands.</p>
        <p><b>Key features:</b></p>
          <ul>
            <li><p>Provides IFRAME and DIV modes</p></li>
            <li><p>Capable of handling markdown editing.</p></li>
            <li><p>Contains a modular library to load the necessary functionality on demand.</p></li>
            <li><p>Provides a fully customizable toolbar.</p></li>
          </ul>
        </ejs-richtexteditor>
             <ejs-uploader ref="uploadObj" :asyncSettings= "path"
            :dropArea = "dropElement" :success= "onImageUploadSuccess" ></ejs-uploader>
        </div>
    </div>
</div>

</div>
</template>

<script>
import Vue from "vue";
import { RichTextEditorPlugin, Toolbar, Link, Image, Count, HtmlEditor, QuickToolbar, Table ,NodeSelection} from "@syncfusion/ej2-vue-richtexteditor";
import {UploaderPlugin} from "@syncfusion/ej2-vue-inputs";
Vue.use(RichTextEditorPlugin);
Vue.use(UploaderPlugin);

export default Vue.extend({
    data: function() {
        return {
           selection: new NodeSelection(),
            range: null,
            dropElement: '.e-richtexteditor',
            saveSelection : null,
          insertImageSettings: {
                    saveUrl: "[SERVICE_HOSTED_PATH]/api/uploadbox/Save",
                    path: "../Files/"
                },
                 path:  {
            saveUrl: '[SERVICE_HOSTED_PATH]/api/uploadbox/Save'
          },
        };
    },
    methods: {
        onImageUploadSuccess: function(args){
        this.$refs.rteObj.ej2Instances.contentModule.getEditPanel().focus();
        this.range = this.selection.getRange(document);
        this.saveSelection = this.selection.save(this.range, document);
        var fileUrl = document.URL + this.$refs.rteObj.ej2Instances.insertImageSettings.path + args.file.name;
        this.$refs.rteObj.ej2Instances.executeCommand('createLink', { url: fileUrl, text: fileUrl, selection: this.saveSelection });

        if (this.$refs.rteObj.ej2Instances.formatter.getUndoRedoStack().length === 0) {
                        this.$refs.rteObj.ej2Instances.formatter.saveData();
                    }
        saveSelection.restore();
        this.$refs.rteObj.ej2Instances.executeCommand('createLink', { url: fileUrl, text: fileUrl, selection: saveSelection });
        this.$refs.rteObj.ej2Instances.formatter.saveData();
        this.$refs.rteObj.ej2Instances.formatter.enableUndo(this.$refs.rteObj.ej2Instances);
        this.$refs.uploadObj.ej2Instances.clearAll();
        }
    },
    provide:{
        richtexteditor:[Toolbar, Link, Image, Count, HtmlEditor, QuickToolbar, Table]
    }
});
</script>

To config server-side handler, refer the below code.

int x = 0;
string file;
 [AcceptVerbs("Post")]
        public void Save()
        {
            try
            {
                var httpPostedFile = System.Web.HttpContext.Current.Request.Files["UploadFiles"];
                file = httpPostedFile.FileName;
                if (httpPostedFile != null)
                {
                    Console.WriteLine(System.Web.HttpContext.Current.Server.MapPath("~/Files"));
                    var fileSave = System.Web.HttpContext.Current.Server.MapPath("~/Files");
                    if (!Directory.Exists(fileSave))
                    {
                        Directory.CreateDirectory(fileSave);
                    }
                    var fileName = Path.GetFileName(httpPostedFile.FileName);
                    var fileSavePath = Path.Combine(fileSave, fileName);
                    while (System.IO.File.Exists(fileSavePath))
                    {
                        file = "rte" + x + "-" + fileName;
                        fileSavePath = Path.Combine(fileSave, file);
                        x++;
                    }
                    if (!System.IO.File.Exists(fileSavePath))
                    {
                        httpPostedFile.SaveAs(fileSavePath);
                        HttpResponse Response = System.Web.HttpContext.Current.Response;
                        Response.Clear();
                        Response.Headers.Add("name", file);
                        Response.ContentType = "application/json; charset=utf-8";
                        Response.StatusDescription = "File uploaded succesfully";
                        Response.Headers.Add("url", fileSavePath);
                        Response.End();
                    }
                }
            }
            catch (Exception e)
            {
                HttpResponse Response = System.Web.HttpContext.Current.Response;
                Response.Clear();
                Response.ContentType = "application/json; charset=utf-8";
                Response.StatusCode = 204;
                Response.Status = "204 No Content";
                Response.StatusDescription = e.Message;
                Response.End();
            }
        }

File attachment in React Rich text editor component

20 Mar 202312 minutes to read

The Rich Text Editor allows you to attach a file based on the file upload. You can attach your files using the file upload or drag-and-drop from your local path. When the file upload gets success, the attachment link inserts into the content.

In the below sample, configure the saveUrl and path properties to achieve file attachments.

    1.saveUrl: Provides service URL to save the files.
    2.path: Specifies the location to store the image.

The following sample illustrates how to attach a file in the Rich Text Editor.

[Class-component]

import * as ReactDOM from 'react-dom';
import * as React from 'react';
import { RichTextEditorComponent, HtmlEditor, Inject, Toolbar, QuickToolbar, Image, Link, NodeSelection, IHtmlFormatterModel } from '@syncfusion/ej2-react-richtexteditor';
import { SampleBase } from '../common/sample-base';
import { UploaderComponent } from '@syncfusion/ej2-react-inputs/src/uploader';
export class ImageSample extends SampleBase<{}, {}> {

    public rteObj: RichTextEditorComponent;
    public uploadObj: UploaderComponent;
    public selection: NodeSelection = new NodeSelection();
    public range: Range;
    public asyncSettings: object;
    public insertImageSetting: object;
    public saveSelection: NodeSelection;
    customHTMLModel: IHtmlFormatterModel;
    public dropElement;
    constructor(props: {}) {
        this.asyncSettings = {
            saveUrl: '[SERVICE_HOSTED_PATH]/api/uploadbox/Save'
        };
        this.insertImageSetting = {
            saveUrl: '[SERVICE_HOSTED_PATH]/api/uploadbox/Save',
            path: '../Files/'
        };
        this.dropElement = '.e-richtexteditor'
    }

    public onUploadSuccess(args: any): void {
        (this.rteObj.contentModule.getEditPanel() as HTMLElement).focus();
        this.range = this.selection.getRange(document);
        this.saveSelection = this.selection.save(this.range, document);
        var fileUrl = document.URL + this.rteObj.insertImageSettings.path + args.file.name;
        if (this.rteObj.formatter.getUndoRedoStack().length === 0) {
            this.rteObj.formatter.saveData();
        }
        saveSelection.restore();
        this.rteObj.executeCommand('createLink', { url: fileUrl, text: fileUrl, selection: saveSelection });
        this.rteObj.formatter.saveData();
        this.rteObj.formatter.enableUndo(rteObj);
        this.uploadObj.clearAll();
    }
    render() {
        return (
            <div className='control-pane'>
                <div className='control-section' id="rteTools">
                    <div className='rte-control-section'>
                        <RichTextEditorComponent id="defaultRTE" ref={(richtexteditor) => { this.rteObj = richtexteditor; }} insertImageSettings={this.insertImageSetting}>
                            <Inject services={[Toolbar, Image, Link, HtmlEditor, QuickToolbar]} />
                        </RichTextEditorComponent>
                        <UploaderComponent id='fileUpload' type='file' ref={(scope) => { this.uploadObj = scope }}
                            asyncSettings={this.asyncSettings} dropArea={this.dropElement} success={this.onUploadSuccess.bind(this)}
                        ></UploaderComponent>
                    </div>
                </div>
            </div>
        );
    }
}

[Functional-component]

import * as ReactDOM from 'react-dom';
import * as React from 'react';
import { RichTextEditorComponent, HtmlEditor, Inject, Toolbar, QuickToolbar, Image, Link, NodeSelection, IHtmlFormatterModel } from '@syncfusion/ej2-react-richtexteditor';
import { SampleBase } from '../common/sample-base';
import { UploaderComponent } from '@syncfusion/ej2-react-inputs/src/uploader';
function ImageSample(){
  let rteObj: RichTextEditorComponent;
  let uploadObj: UploaderComponent;
  let selection: NodeSelection = new NodeSelection();
  let range: Range;
  let asyncSettings: object;
  let insertImageSetting: object;
  let saveSelection: NodeSelection;
  customHTMLModel: IHtmlFormatterModel;
  let dropElement;
      asyncSettings = {
          saveUrl: '[SERVICE_HOSTED_PATH]/api/uploadbox/Save'
      };
      insertImageSetting = {
          saveUrl: '[SERVICE_HOSTED_PATH]/api/uploadbox/Save',
          path: '../Files/'
      };
      dropElement = '.e-richtexteditor'

  function onUploadSuccess(args: any): void {
      (rteObj.contentModule.getEditPanel() as HTMLElement).focus();
      range = selection.getRange(document);
      saveSelection = selection.save(range, document);
      var fileUrl = document.URL + rteObj.insertImageSettings.path + args.file.name;
      if (rteObj.formatter.getUndoRedoStack().length === 0) {
          rteObj.formatter.saveData();
      }
      saveSelection.restore();
      rteObj.executeCommand('createLink', { url: fileUrl, text: fileUrl, selection: saveSelection });
      rteObj.formatter.saveData();
      rteObj.formatter.enableUndo(rteObj);
      uploadObj.clearAll();
  }
  return (
      <div className='control-pane'>
          <div className='control-section' id="rteTools">
              <div className='rte-control-section'>
                  <RichTextEditorComponent id="defaultRTE" ref={(richtexteditor) => { rteObj = richtexteditor; }} insertImageSettings={insertImageSetting}>
                      <Inject services={[Toolbar, Image, Link, HtmlEditor, QuickToolbar]} />
                  </RichTextEditorComponent>
                  <UploaderComponent id='fileUpload' type='file' ref={(scope) => { uploadObj = scope }}
                      asyncSettings={asyncSettings} dropArea={dropElement} success={onUploadSuccess.bind(this)}
                  ></UploaderComponent>
              </div>
          </div>
      </div>
  );
}

export default ImageSample;

To configure server-side handler, refer the below code.

int x = 0;
string file;
 [AcceptVerbs("Post")]
        public void Save()
        {
            try
            {
                var httpPostedFile = System.Web.HttpContext.Current.Request.Files["UploadFiles"];
                file = httpPostedFile.FileName;
                if (httpPostedFile != null)
                {
                    Console.WriteLine(System.Web.HttpContext.Current.Server.MapPath("~/Files"));
                    var fileSave = System.Web.HttpContext.Current.Server.MapPath("~/Files");
                    if (!Directory.Exists(fileSave))
                    {
                        Directory.CreateDirectory(fileSave);
                    }
                    var fileName = Path.GetFileName(httpPostedFile.FileName);
                    var fileSavePath = Path.Combine(fileSave, fileName);
                    while (System.IO.File.Exists(fileSavePath))
                    {
                        file = "rte" + x + "-" + fileName;
                        fileSavePath = Path.Combine(fileSave, file);
                        x++;
                    }
                    if (!System.IO.File.Exists(fileSavePath))
                    {
                        httpPostedFile.SaveAs(fileSavePath);
                        HttpResponse Response = System.Web.HttpContext.Current.Response;
                        Response.Clear();
                        Response.Headers.Add("name", file);
                        Response.ContentType = "application/json; charset=utf-8";
                        Response.StatusDescription = "File uploaded succesfully";
                        Response.Headers.Add("url", fileSavePath);
                        Response.End();
                    }
                }
            }
            catch (Exception e)
            {
                HttpResponse Response = System.Web.HttpContext.Current.Response;
                Response.Clear();
                Response.ContentType = "application/json; charset=utf-8";
                Response.StatusCode = 204;
                Response.Status = "204 No Content";
                Response.StatusDescription = e.Message;
                Response.End();
            }
    }